void draw() {
  //  rotateX(.5*PI);
  //  translate(0, -3000, -1000);
  rotateZ(PI);
  //  rotateY(-.5);
  
  // clean background
  background(255);

  // peasy cam  
  peasyCamPosition = cam.getPosition(); // get position
  rotations = cam.getRotations(); // get rotations

    // for animation
  float tdiff = (float)(millis() - tStart)/1000.0f;

  // mouse interaction
  if (mousePressed == true) { // If the mouse is pressed,
    lights(); // turn on lights
  }

  // axises
  pushStyle();
  stroke(#FF0000, 30); // x-axis
  line(-width/2, 0, 0, width/2, 0, 0);
  stroke(#0000FF, 30); // y-axis
  line(0, -height/2, 0, 0, height/2, 0);
  stroke(100, 80, 50); // z-axis
  line(0, 0, height*2, 0, 0, 0);
  popStyle();
  
  // HUD
  pushAll();
  cam.beginHUD();
//  textAlign(LEFT, CENTER);
//  for (int i = 0; i < 3; i++) {
//    fill(palette[i]);
//    text(keywords[i], leftBorder, height -topBorder -60*i); // draw on the 2d screen.
//  }
//  fill(#FFFF00);
//  text(frameCount, leftBorder, height -topBorder -60*3); // draw on the 2d screen.
  
  
  
  textAlign(LEFT, CENTER);
  textFont(font0, 40);
  fill(#FFFFFF);
  text("SKYSCRAPERS", 30, 30);
  
  fill(100, 90);
  textFont(font3, 16);
  text("Seattle Public Library Data Set 2009-2012", 30, 80);
  textAlign(RIGHT, CENTER);
  text("MAT259, Data Visualization", width - 50, height - topBorder - 20*2);
  text("Final Project: 3D Visualization", width - 50, height - topBorder - 20*1);
  text("Jay Byungkyu Kang", width - 50, height - topBorder);
//  text("Press key 1-5", 1004, 50);
//  text("1 : Full sphere, 2 : Lines, 3: Spheres", 1004, 65);
//  text("4: Spheres with Dates text, 5: Book title texts", 1004, 80);
  
  //Dewey class text
  textAlign(LEFT, TOP);
  rectMode(CORNER);
  noStroke();
  for (int i = 0; i < 10; i++) {
    fill(36*i, 100, 70, 70);
    rect(leftBorder, topBorder + 30*i, 11, 11); // color box labels
    fill(100, 90);
    text(legends[i], leftBorder + 12, topBorder + 30*i); // dewey legends
  }
  
  textFont(font2, 16);
  for (int i = 0; i < 3; i++) {
    fill(palette[i]);
    text(keywords[i], leftBorder, 400 + 30*i); // draw on the 2d screen.
  }
  fill(#FFFF00, 30);
  text(frameCount, leftBorder, 400 + 30*3); // draw on the 2d screen.
  
  // controls
  textFont(font3, 16);
  fill(100, 80);
  for (int i = 0; i < 7; i++) {
    fill(100, 90);
    text(controls[i], leftBorder, 560 + 30*i); // dewey legends
  }

  cam.endHUD();
  popAll();

  // spinning effect
  //  rotateY((tdiff % 10.0)/10.0 * TWO_PI );
  //  translate(0, -200, 0);

  //  box(400, 100, 400);
  //  sphere(150);

  // central pyramids
  if (enablePyramid){
    deltas();
  }

  // floor circle and labels
  pushMatrix();
  stroke(100, 60);
  textAlign(RIGHT);
  rotateZ(radians(-60));
  for (int i = 0; i < 3; i++) {
    fill(palette[i], 60);
    arc(0, 0, width/2, width/2, radians(120*i), radians(120*(i+1)));
//    fill(palette[i]);
//    text(keywords[i],0,0);
    line(width/2, 0, 0, -width/2, 0, 0);
  }
  popMatrix();

  // labels 1
  // label facing camera!! __NEED TO FIX__
  pushMatrix();
  rotateX(-0.5*PI);
  fill(#555555);
  for (int i=0; i<48; i++) {
    int label = (i%12)+1;
    text(label, 0, -i*height/20, 0);
  }
  popMatrix();

  // labels 2
  pushMatrix();
  rotateX(-0.5*PI);
  rotateY(-0.5*PI);
  fill(#FF0000);

  for (int i=1; i<48; i++) {
    int label = (i%12)+1;
    text(label, 0, -i*height/20, 0);
  }
  popMatrix();

  // labels 3
  pushMatrix();
  rotateX(-0.5*PI);
  rotateY(-PI);
  fill(#0000FF);

  for (int i=0; i<4; i++) {
    int label = i+startYear;
    text(label, 0, - height/20 - 12*i*height/20, 0);
  }
  popMatrix();
  
  // labels 4
  pushMatrix();
  rotateX(-0.5*PI);
  rotateY(-1.5*PI);
  fill(#0000FF);

  for (int i=0; i<4; i++) {
    int label = i+startYear;
    text(label, 0, - height/20 - 12*i*height/20, 0);
  }
  popMatrix();


  // load dataset
  for (int kw = 0; kw < 3; kw++) {

    // print legend
    fill(palette[kw]);

    ArrayList tArray = new ArrayList();
    tArray = mArray.get(kw);
    for (int i = 0; i < tArray.size(); i++) {
      Entity e0 = (Entity) tArray.get(i);

      int next = 1;
      if (i+1 < tArray.size()) {
        Entity e1 = (Entity) tArray.get(i+1);
        next = e1.total;
      }

      // basic palette
      fill(palette[kw], e0.total);
      
      // VIZ transaction distribution
      int count = e0.total;
      pushAll();
      rotateZ(radians(120*kw));
      translate(height/5, 0, i*height/20);
      rotateX(+.5*PI);
      
      // object within threshold distance
      boolean in = getDistance(i*height/20);
      if(!enableStroke){
        noStroke();
      }
      
      if (in){
        fill(palette[kw]); // enable color
      }else{
        fill(0, 0, 80, 20);
      }
      
      drawCylinder(e0.total, next, height/20, 4);
      popAll();
      
      // Viz dewey ring
      pushAll();
      
      if (kw == 2 && in){
        float total = (Float)hmapMonth.get(i);
        int totalInt = (int)total;
        noFill();
        strokeWeight(10);
        // 2D Vizualization
        cam.beginHUD();
        float startAngle = 0.0; // starting angle in radian
        for (int j = 0; j < 10; j++) {
          String s = i + "-" + j;
          float val = (Float)hmapDewey.get(s);
          val = (val/total)*TWO_PI;
          stroke(36*j, 100, 80, 70);
          arc(width/2, height/2, 0.8*height, 0.8*height, startAngle, startAngle + val);
          startAngle += val;
        }
        
        if (enableStat){
          textFont(font2, 180);
          textAlign(CENTER, CENTER);
          fill(palette[3], 40);
          text(totalInt, width/2, height/2);
          textFont(font0, 40); // Manteka 40
          text(e0.label, width/2 - 50, height/2 + 100); ////////////////
        }
        cam.endHUD();
      }
      popAll();

      // VIZ dewey distribution
      if (enableDewey){
        pushStyle();
        noStroke();
        for (int j=0; j<10; j++) {
          pushMatrix();
          rotateZ(radians(36*j));
          translate(height/5 + (height/5) * kw, 0, i*height/20);
          //        float alphaVal = getAlpha((height/10)*kw, 0, i*height/20);
          //        fill(palette[kw], alphaVal);
          int val = e0.deweys[j];
          fill(36*j, 100, 80, map(val, 0, 200, 30, 100));
          //        rotateX(0.5*PI);
          //        println(e0.deweys[j]);
          //        ellipse(0, 0, val, val);
          
          // arguments:: drawCylinder(topRadius, bottomRadius, tall, sides)
          // drawCylinder(0, val, val, 3); // pyramid
          drawCylinder(e0.total, next, height/20, 4);
          popMatrix();
        }
        popStyle();
      }


      // dewey circles
      pushMatrix();
      //        if (keyIndex == i) {
      //          for (int j=0; j<10; j++) {
      //            fill(36*j, 100, 80);
      //            translate(100, 0, 0);
      //            rotateZ(radians(36*j));
      //            sphere(e0.deweys[j]);
      //          }
      //        }
      popMatrix();
    }
  }

}

